bl_info = {
    "name": "Save Temporary Version File",
    "author": "Kursad Karatas",
    "version": (0, 0, 1),
    "blender": (2, 79, 0),
    "location": "File menu",
    "warning": "",
    "description": "Versioning files without versioning files",
    "category": "User Interface"
}


import bpy
import os 
import glob 
import time
import tempfile
from bpy.props import *
from bpy_extras.io_utils import ExportHelper

#TempFolder="P:\\.cache\\BlenderVersions"
#TempFolder=""

def hashedName(fname):
    

    txtime=str(time.time()).split(".")[0]
    
    return fname+"_"+txtime+".blend"

def getFileName():

    filename = bpy.path.basename(bpy.context.blend_data.filepath)
    filename = os.path.splitext(filename)[0]

    return filename

def saveTempFile(fname):

    print(fname)

    if TempFolder:
        print("Temp folder is",TempFolder)
        finalpath=os.path.join(TempFolder,fname)
        print("Final Path",finalpath)
        
    else:
    
        tempfolder=tempfile.gettempdir()
        
        finalpath=os.path.join(tempfolder,fname)
        print("Temp folder is",tempfolder)
        print("Final Path",finalpath)
    
    #bpy.ops.wm.save_as_mainfile(finalpath copy=True)
    bpy.ops.wm.save_as_mainfile(filepath=finalpath, copy=True)


    return finalpath


def saveTemp():
    return os.path.basename(newFile)

class OP_saveTemp(bpy.types.Operator):
    bl_idname = "wm.savetemp"
    bl_label = "Save Temporary"
    
    def execute(self,context):
        
        filename=getFileName()
        saveIt=saveTempFile(hashedName(filename))

        #self.report()
        self.report({'WARNING', 'INFO'}, "The file is saved to "+saveIt)   

        return {'FINISHED'}   
    

def menu_draw(self, context):
    self.layout.separator()
    self.layout.operator(OP_saveTemp.bl_idname, OP_saveTemp.bl_label, icon='ZOOMIN')
    
def register():
    bpy.utils.register_class(OP_saveTemp)
    bpy.types.INFO_MT_file.append(menu_draw)
    
    #addShortcut()
   
def unregister():
    bpy.utils.unregister_class(OP_saveTemp)
    bpy.types.INFO_MT_file.remove(menu_draw)
    
    
if __name__ == "__main__":
    register()

